    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------
    028     * CategoryURLGenerator.java
    029     * -------------------------
    030     * (C) Copyright 2002-2008, by Richard Atkinson and Contributors.
    031     *
    032     * Original Author:  Richard Atkinson;
    033     * Contributors:     David Gilbert (for Object Refinery Limited);
    034     *
    035     * Changes:
    036     * --------
    037     * 05-Aug-2002 : Version 1, contributed by Richard Atkinson;
    038     * 09-Oct-2002 : Fixed errors reported by Checkstyle (DG);
    039     * 10-Apr-2003 : Replaced reference to CategoryDataset with
    040     *               KeyedValues2DDataset (DG);
    041     * 23-Apr-2003 : Switched around CategoryDataset and KeyedValues2DDataset
    042     *               (again) (DG);
    043     * 13-Aug-2003 : Added clone() method (DG);
    044     * 14-Jun-2004 : Removed clone() method - classes that implement the interface
    045     *               should implement the PublicCloneable interface instead,
    046     *               wherever possible (DG);
    047     * ------------- JFREECHART 1.0.x ---------------------------------------------
    048     * 02-Feb-2007 : Removed author tags from all over JFreeChart sources (DG);
    049     * 13-Dec-2007 : Updated API docs (DG);
    050     *
    051     */
    052
    053    package org.jfree.chart.urls;
    054
    055    import org.jfree.data.category.CategoryDataset;
    056
    057    /**
    058     * A URL generator for items in a {@link CategoryDataset}.
    059     */
    060    public interface CategoryURLGenerator {
    061
    062        /**
    063         * Returns a URL for one item in a dataset. As a guideline, the URL
    064         * should be valid within the context of an XHTML 1.0 document.  Classes
    065         * that implement this interface are responsible for correctly escaping
    066         * any text that is derived from the dataset, as this may be user-specified
    067         * and could pose a security risk.
    068         *
    069         * @param dataset  the dataset.
    070         * @param series  the series (zero-based index).
    071         * @param category  the category.
    072         *
    073         * @return A string containing the URL.
    074         */
    075        public String generateURL(CategoryDataset dataset, int series,
    076                int category);
    077
    078    }